<template>
  <div>
    <v-toolbar color="primary-accent" dark>
      <v-toolbar-title>Etapes</v-toolbar-title>
    </v-toolbar>
    <v-row v-for="(recipeStep, i) in recipeSteps" :key="'RecipeStepInput' + i">
      <v-col cols="10">
        <v-row dense >
          <v-col cols="12">
              <v-textarea rows="2" auto-grow required hide-details :label="'Etape ' + (i + 1)" outlined v-model="recipeStep.Text">
                {{recipeStep.Text}}
              </v-textarea>
          </v-col>
        </v-row>
      </v-col>
      <v-col cols="2" class="text-center my-auto">
        <v-btn fab small color="error" title="Supprimer l'étape" @click="removeRecipeStep(recipeStep)">
          <v-icon dark>mdi-delete</v-icon>
        </v-btn>
      </v-col>
    </v-row>
    <v-toolbar flat>
      <v-spacer></v-spacer>
      <v-btn fab small color="secondary" class="float-right" @click="addField()">
        <v-icon dark>mdi-plus</v-icon>
      </v-btn>
    </v-toolbar>
  </div>
</template>

<script lang="ts">
import VueWithMixins from "../../../assets/VueWithMixins";
import Component from "vue-class-component";
import RecipeStep from "../../../transport/RecipeStep";
import { Watch } from "vue-property-decorator";

@Component
export default class RecipeStepsForm extends VueWithMixins {
  recipeSteps: RecipeStep[] = [];

  mounted() {
    this.recipeSteps.push(new RecipeStep(""));
  }
  @Watch("recipeSteps", { deep: true })
  onStepsChanged() {
    this.$emit("steps-update", this.recipeSteps);
  }
  addField() {
    if (!this.recipeSteps.find(step => step.Text === ""))
      this.recipeSteps.push(new RecipeStep());
    else
      this.Toast.warning("Impossible d'ajouter une étape si la précédent est incomplète.")
  }
  private removeRecipeStep(step: RecipeStep) {
      this.recipeSteps.splice(this.recipeSteps.indexOf(step), 1);
  }
}
</script>
